#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>

//LCD Tester, fr mega8 @ 8MHz, by Benedikt

void delay (unsigned int us);

#ifndef cbi
#define cbi(sfr, bit)     (_SFR_BYTE(sfr) &= ~_BV(bit)) 
#endif
#ifndef sbi
#define sbi(sfr, bit)     (_SFR_BYTE(sfr) |= _BV(bit))  
#endif

//PortB:
#define 	M		1

//PORTC:
#define		D		PORTC	//(D1,D2=PORTC0,1)

// PORTD:
#define		FLM		0
#define 	LP		1
#define		CP		2

int main(void)
{ 	unsigned char x,y=0;	

	DDRC=255;
	DDRB=255;
	DDRD=255;

	TCCR1A=(1<<COM1A0);			//Toggle OC1B at CTC

	OCR1A= 32;					//M (AC Drive)

	TCCR1B=(1<<WGM12)|5;		//Enable CTC, Clock= 7,8kHz

for (;;)
	{
	for (y=0; y<34; y++)
		{
		cbi(PORTD, FLM);
		if (y==0)				//Set First Line Marker (VSync)
			sbi(PORTD, FLM);
		for (x=0; x<241; x++)
			{
			D=~D;				//Toggle Data
			asm("nop"); 
			asm("nop"); 
			sbi(PORTD,CP);		//Clock
			asm("nop"); 
			asm("nop"); 
			cbi(PORTD,CP);
			}
		delay(1);
		sbi (PORTD, LP);		//Latch Pulse (HSync)
		delay(1);
		cbi (PORTD, LP);
		}
	}
}

void delay (unsigned int us)    //Fr 8MHz kalibriert !
{   unsigned int i;
    for (i=0;i<us;i++)
    { asm("nop");  }
}

